int left_motor_dir = 12;
int left_motor_power = 3;
int left_motor_brake = 9;
float left_motor_power_forward_mod = 1.00;
float left_motor_power_backward_mod = 1.00;

int right_motor_dir = 13;
int right_motor_power = 11;
int right_motor_brake = 8;
float right_motor_power_forward_mod = 0.60;
float right_motor_power_backward_mod = 1.00;

int ir_sensor_1 = 3;
int ir_sensor_1_val = 0;
int ir_sensor_1_mapped_val = 0;
int ir_sensor_1_min = 55;
int ir_sensor_1_max = 76;

int ir_sensor_2 = 4;
int ir_sensor_2_val = 0;
int ir_sensor_2_mapped_val = 0;
int ir_sensor_2_min = 60;
int ir_sensor_2_max = 85;

int ir_sensor_3 = 5;
int ir_sensor_3_val = 0;
int ir_sensor_3_mapped_val = 0;
int ir_sensor_3_min = 85;
int ir_sensor_3_max = 105;

int ir_threshhold = 100;

int min_speed = 95;
int medium_speed = 135;
int max_speed = 200;

boolean last_direction = 0; // left is 0, right is 1

void setup() {
  Serial.begin(9600);
  
  pinMode(left_motor_dir, OUTPUT);   
  pinMode(left_motor_power, OUTPUT);
  pinMode(left_motor_brake, OUTPUT);

  pinMode(right_motor_dir, OUTPUT);   
  pinMode(right_motor_power, OUTPUT);
  pinMode(right_motor_brake, OUTPUT);   
  
  digitalWrite(left_motor_brake, LOW);
  digitalWrite(right_motor_brake, LOW);
}

void loop() {
  read_sensors();
  print_sensor_readings_to_serial();
  
  if(ir_sensor_1_mapped_val > ir_threshhold && ir_sensor_2_mapped_val > ir_threshhold && ir_sensor_3_mapped_val > ir_threshhold) {
    if(last_direction == 0) {
      turn_left();
    }
    if(last_direction == 1) {
      turn_right();
    }
  }
  else {  
    
    if(ir_sensor_2_mapped_val < ir_threshhold ) {
      move_forward();
    }
    else {
      if(ir_sensor_1_mapped_val < ir_threshhold ) {
        turn_right();
      }
      
      if(ir_sensor_3_mapped_val < ir_threshhold ) {
        turn_left();
      }
    }
  }  
  

  /*
  if(ir_sensor_1_mapped_val < ir_threshhold && ir_sensor_2_mapped_val < ir_threshhold && ir_sensor_3_mapped_val < ir_threshhold) {
    stop();
  }
  
  if(ir_sensor_2_mapped_val < ir_threshhold) {
    move_forward();
  }
  else {
    if(ir_sensor_1_mapped_val < ir_threshhold ) {
      turn_left();
    }
    else {
      if(ir_sensor_3_mapped_val < ir_threshhold ) {
        turn_right();
      }
    }
  }
  */
}

void print_sensor_readings_to_serial() {
  Serial.print("Sensor 1 Val: "); Serial.print(ir_sensor_1_val); Serial.print(" | "); Serial.print("Sensor 1 Mapped: "); Serial.print(ir_sensor_1_mapped_val); Serial.print(" | ");;
  Serial.print("Sensor 2 Val: "); Serial.print(ir_sensor_2_val); Serial.print(" | "); Serial.print("Sensor 2 Mapped: "); Serial.print(ir_sensor_2_mapped_val); Serial.print(" | ");;
  Serial.print("Sensor 3 Val: "); Serial.print(ir_sensor_3_val); Serial.print(" | "); Serial.print("Sensor 3 Mapped: "); Serial.print(ir_sensor_3_mapped_val); 
  
  Serial.print("\n");
}

void read_sensors() {
  ir_sensor_1_val = analogRead(ir_sensor_1);
  ir_sensor_2_val = analogRead(ir_sensor_2);
  ir_sensor_3_val = analogRead(ir_sensor_3);
  
  
  ir_sensor_1_mapped_val = map(ir_sensor_1_val, ir_sensor_1_min, ir_sensor_1_max, 0, 255);
  ir_sensor_1_mapped_val = constrain(ir_sensor_1_mapped_val, 0, 255);
  ir_sensor_2_mapped_val = map(ir_sensor_2_val, ir_sensor_2_min, ir_sensor_2_max, 0, 255);
  ir_sensor_2_mapped_val = constrain(ir_sensor_2_mapped_val, 0, 255);
  ir_sensor_3_mapped_val = map(ir_sensor_3_val, ir_sensor_3_min, ir_sensor_3_max, 0, 255);
  ir_sensor_3_mapped_val = constrain(ir_sensor_3_mapped_val, 0, 255);
  
}

void move_forward() {
  digitalWrite(left_motor_brake, LOW);
  digitalWrite(right_motor_brake, LOW);
  
  digitalWrite(left_motor_dir,HIGH);
  digitalWrite(right_motor_dir, HIGH);
  
  analogWrite(left_motor_power, int(max_speed * left_motor_power_forward_mod));
  analogWrite(right_motor_power, int(max_speed * right_motor_power_forward_mod));
}

void turn_right() {
  last_direction = 1;
  
  digitalWrite(left_motor_brake, LOW);
  digitalWrite(right_motor_brake, HIGH);
  
  digitalWrite(left_motor_dir, HIGH);
  digitalWrite(right_motor_dir, LOW);
  
  analogWrite(left_motor_power, int(max_speed * left_motor_power_forward_mod));
  analogWrite(right_motor_power, 0);
  
  delay(50);
}

void turn_left() {
  last_direction = 0;
  
  digitalWrite(left_motor_brake, HIGH);
  digitalWrite(right_motor_brake, LOW);
  
  digitalWrite(left_motor_dir, LOW);
  digitalWrite(right_motor_dir, HIGH);
  
  analogWrite(left_motor_power, 0);
  analogWrite(right_motor_power, int(max_speed * right_motor_power_forward_mod));
  
  delay(50);
}

void stop() {
  digitalWrite(left_motor_brake, HIGH);
  digitalWrite(right_motor_brake, HIGH);
}
